VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7050
   ClientLeft      =   240
   ClientTop       =   1545
   ClientWidth     =   7425
   LinkTopic       =   "Form1"
   ScaleHeight     =   7050
   ScaleWidth      =   7425
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'------------------------------------
' TrueVision Car + Terrain example
'------------------------------------
'
' by Sylvain Dupont
'
'---------------------------------------
' ANY PROBLEM, ANY BUG, WRITE ME AT
' sylvain@truevision3d.com
'----------------------------------------

Option Explicit

'Global declarations
Public TV As New TrueVision8
Public Scene As New Scene8
Public TexFactory As New TextureFactory8
Public MatFactory As New MaterialFactory8
Public Effects As New GraphicEffect8
Public Particle As New ParticleSystem8
Public Land As New Landscape8
Public Light As New LightEngine8
Public Inp As New InputEngine8
Public Camera As New Camera8
Public Sound As New SoundEngine8

'Car mesh
Public Car As Mesh8

Public Sub Main8()
  
  'Show the driver windows
  If TV.ShowDriverDialog = False Then End
  
  TV.DisplayFPS = True
  'Init the 3D stuff
  TV.Initialize
  
  'Set the default directory for the media files
  TV.SetSearchDirectory App.Path
  
  
  'Load grass texture for the terrain
  'Note that TrueVision can load DDS textures.
  'You can create DDS textures with Dxtex delivred with DirectX8 sdk
  TexFactory.LoadTexture "new_2.bmp", "terrain"
  
 'Set the general settings for the scene
  Scene.SetSceneBackGround 0, 0, 0
  Scene.SetViewFrustum 90, 1024
 
 'Load the sky (TrueVision can read JPG, BMP, GIF, DDS, PNG)
 TexFactory.LoadTexture "down.jpg", "Up"
 TexFactory.LoadTexture "left.jpg", "Left"
 TexFactory.LoadTexture "up.jpg", "Down"
 TexFactory.LoadTexture "right.jpg", "Right"
 TexFactory.LoadTexture "front.jpg", "Front"
 TexFactory.LoadTexture "back.jpg", "Back"

 'Apply the sky in the scene
 Scene.SetSkyTexture GetTex("Front"), GetTex("Back"), GetTex("Left"), GetTex("Right"), GetTex("up"), GetTex("down")

 'LANSCAPE CREATION
 'New function from TrueVision8
 'You can load any heightmap (any size)
 'and you choose the position and the size of the heightmap in the landscape
 'Note that there is a great AffineTerrain function that makes the terrain more curved.
 
 'I use here 4x4 terrains (1024x1024) but you can try numbers like 8 or 16 (4096x4096 !)
 'On My computer 4x4 runs at 60FPS and 16x16 runs at 40 FPS !
 
 'The heightmap has values from 0 to 255. You can scale them with this SetFactorY method.
 Land.SetFactorY 0.4
 Land.GenerateHugeTerrain "height.jpg", TV_PRECISION_AVERAGE, 4, 4, 0, 0, True
 
 'For testing the best of the terrain engine try this :
 'Land.SetFactorY 5
 'Land.GenerateHugeTerrain "height.jpg", TV_PRECISION_AVERAGE, 16, 16, 0, 0, True
 
 'Load the car. TVO is the format of TrueVision Meshes.
 'Soon you will have a converter for this format (3DS, X, MS3D...)
 'The TVO file use is very easy to understand
 'If you want to know how to create a TVO file, just look at the Tutorial4
 Dim CarFile As New FileTVO
 
 CarFile.OpenTVO "car1upd.tvo"
  Set Car = CarFile.LoadMesh("Car")
 CarFile.CloseTVO
 
  'and his texture
 TexFactory.LoadTexture "cartex.jpg", "CarTexture"
 Car.SetTexture GetTex("CarTexture"), 1
 
 'Change the texture tiling
 Land.SetTextureScale 2, 2
 Land.SetTexture GetTex("Terrain")
 Car.SetMaterial 0
 Car.SetBlendingMode TV_BLEND_NO  'fix a TVO bug.
 
 'create trees
 ' Here the trees are textured billboards.
 ' The texture contains a transparency alpha-channel
 ' To use it, set a black color with alpha in the colorkey argument.
 ' Black : RGBA(0,0,0,1) or &hFF000000
 
 Dim treeTex(2) As Texture8
 Set treeTex(1) = TexFactory.LoadTexture("tree3c.dds", , , , RGBA(0, 0, 0, 1))
 Set treeTex(2) = TexFactory.LoadTexture("tree4c.dds", , , , RGBA(0, 0, 0, 1))
 
 'Add billboards randomly on the terrain
 'Note that the Billboards height is negative because the texture trees in bottom-top oriented.
 Dim x As Single, z As Single, y As Single
 Dim Trees(100) As Mesh8
  
 Dim i As Long
 For i = 1 To 100
     x = Rnd * 1024
     z = Rnd * 1024
     y = Land.GetHeight(x, z) + 5
     Set Trees(i) = Scene.CreateBillboard(treeTex(Int(Rnd * 2) + 1), x, y + 35, z, 40, -40)
     Trees(i).ComputeSphere
  Next i

'Enable mip mapping for more speed. Optional
'Scene.EnableMipMapping

' Create sounds
  Sound.Sound.Waves.LoadWaveFromFile "drive.wav", "Driving"
  Sound.Sound.Waves("Driving").Play True
  'Sound.Play GetSound("Driving"), True


'Initialize the smoke effect
TexFactory.LoadTexture "smoke.bmp", "Smoke", 256, 256
Particle.CreateBillboardSystem 50, 0, 10, Vector(0, 0, 0), 0, GetTex("Smoke")
Particle.SetParticleTexture GetTex("Smoke")
Particle.SetPraticleAutoGenerateMode True, 0.4, 0.4, 0.4, 0.4, 0.5, 0, 0.1, 0, 0.01, 0.01, 0.01
Particle.SetAlphaBlendingMode TV_CHANGE_ALPHA, D3DBLEND_SRCALPHA, D3DBLEND_ONE
  

Dim PosX As Single, PosY As Single, PosZ As Single, ang As Single, Fin As Integer
Dim CamPosX As Single, CamPosZ As Single, ang2 As Single, ang3 As Single, Posy1 As Single
Dim Posy2 As Single, Speed As Single
 
 'Put the car in the center of the terrain, the camera will go to it !
 PosX = 500
 PosZ = 500
 
 
 'Fade in  ( really simplified, you have to call it once with the desired
 'speed in milliseconds)
 Effects.FadeIn 3000
 
 'Set a fog effect for the terrain only
 Effects.SetFog True, 0, 0, 0, 0, 1, 700
  
 'Game loop
 Dim inter As New InternalObjects8
 Do
   
  'Clear the screen
  TV.Clear
  
  
  'Render the entire landscape
  Land.Render
  
  'Cancel the fog for drawing the sky
  TV.Start2D
  
  'Render the sky (you have to call this method just after the terrain rendering)
  Scene.RenderSky
  
  'Render the trees and the car
  Scene.RenderAllMeshes
  
  'Particles / Smoke
  Particle.MoveEmettor Vector(PosX - Cos(ang) * 10, PosY, PosZ - Sin(ang) * 10)
  Particle.RenderParticles
  Particle.UpdateParticles TV_UPDATE_GENERATOR Or TV_UPDATE_BOTH
  Particle.SetGeneratorSpeed 50
  
  'ScreenShot Taking takes a few seconds. TV has to convert the color format
  'BackBuffer formats supported : R5G6B5 & X8R8G8B8 & A8R8G8B8
  'other formats can give strange results !
  'ScreenShot Method must be called before the RenderToScreen method
  
'   Sound.Sound.Waves("Driving").Frequency = Speed * 5000 + 5110
 If Inp.IsKeyPressed(TV_KEY_S) = True Then
   TV.ScreenShot "c:\key.bmp"
  End If
  
  'Flip all on the screen
  TV.RenderToScreen
   
  'Input keyboard
   If Inp.IsKeyPressed(TV_KEY_1) = True Then
     Scene.SetRenderMode TV_LINE
   End If
   If Inp.IsKeyPressed(TV_KEY_2) = True Then
     Scene.SetRenderMode TV_POINT
   End If
   If Inp.IsKeyPressed(TV_KEY_3) = True Then
     Scene.SetRenderMode TV_SOLID
   End If
   
   'Car speed management
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
     Speed = Speed - 0.01 * TV.TimeElapsed * (Speed < 2)
   End If
   
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
     Speed = Speed + 0.01 * TV.TimeElapsed * (Speed > -1)
   End If
   PosX = PosX + Cos(ang) * Speed * TV.TimeElapsed * 0.05
   PosZ = PosZ + Sin(ang) * Speed * TV.TimeElapsed * 0.05
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       ang = ang + TV.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       ang = ang - TV.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       PosY = PosY + TV.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
       PosY = PosY - TV.TimeElapsed * 0.05
   End If
   
   'Change the position altritude according to the terrain altitude
   PosY = Land.GetHeight(PosX, PosZ) + 3
   CamPosX = PosX - Cos(ang) * 20
   CamPosZ = PosZ - Sin(ang) * 20
   
   'Check the <
   Posy1 = Land.GetHeight(PosX + Cos(ang) * 10, PosZ + Sin(ang) * 10)
   Posy2 = Land.GetHeight(PosX - Cos(ang) * 10, PosZ - Sin(ang) * 10)
   
   'Get the pitch angle
   ang2 = Atn((Posy1 - Posy2) / 20)
   'Change the speed according to the found angle
   Speed = Speed - ang2 * TV.TimeElapsed / 1000
   If Speed > 4 Then Speed = 4
   If Speed < -1 Then Speed = -1#
   Posy1 = Land.GetHeight(PosX - Sin(ang) * 4, PosZ - Cos(ang) * 4)
   Posy2 = Land.GetHeight(PosX + Sin(ang) * 4, PosZ + Cos(ang) * 4)
   'Get the roll angle
   ang3 = Atn((Posy1 - Posy2) / 8)
   
   
   'Rotate the car according to the terrain.
   Car.SetRotation Rad2Deg(-ang2), 90 - Rad2Deg(ang), Rad2Deg(-ang3)
   
   'Check the limits of the terrain
   If PosX > 1020 Then PosX = 1020
   If PosZ > 1020 Then PosZ = 1020
   If PosX < 4 Then PosX = 4
   If PosZ < 4 Then PosZ = 4
   
   Car.SetPosition PosX, PosY, PosZ
   
   'Place the camera using the Chase function.
   Camera.PurchaseFollowing Car, Vector(0, 3, -4), Vector(0, 1, 0), 5, True, 50
      
   'Follow the landscape
   Camera.SetCameraPosition Camera.GetCameraPosition.x, Land.GetHeight(Camera.GetCameraPosition.x, Camera.GetCameraPosition.z) + 20, Camera.GetCameraPosition.z
    'Test for the escape key. Fade out
    If Inp.IsKeyPressed(TV_KEY_ESCAPE) = True Then
      Fin = 1
      Effects.FadeOut 2000
    End If
 Loop Until Effects.FadeFinished = True And Fin = 1
 
 Set TV = Nothing
 End
 
End Sub



Private Sub Form_Load()
  Main8
End Sub


